Index: /orxonox/branches/gui/guicc/orxonox_gui.cc
===================================================================
--- /orxonox/branches/gui/guicc/orxonox_gui.cc	(revision 1972)
+++ /orxonox/branches/gui/guicc/orxonox_gui.cc	(revision 1973)
@@ -4,27 +4,27 @@
 
 int main( int argc, char *argv[] )
-  {
-    gtk_init (&argc, &argv);
-    Window* orxonoxGUI = new Window("Graphical Orxonox Launcher");
-    orxonoxGUI->connectSignal ("destroy", orxonoxGUI->orxonox_gui_quit);
-    orxonoxGUI->connectSignal ("delete_event", orxonoxGUI->orxonox_gui_quit);
-
-    Frame* Frametest = new Frame ("Test");
-    orxonoxGUI->fill((Frame*) Frametest);
-    Box* box = new Box ('v');
-    Frametest->fill(box);
-
-    CheckButton* button = new CheckButton("test");
-    button->connectSignal ("clicked", orxonoxGUI->orxonox_gui_quit);
-    box->fill(button);
-    Slider* slider = new Slider("testslider", 0, 100);
-    slider->connectSignal ("value_changed", slider->OptionChange);
-    box->fill(slider);
-
-    orxonoxGUI->showall ();
-
-    gtk_main();
-    return 0;
-  }
+{
+  gtk_init (&argc, &argv);
+  Window* orxonoxGUI = new Window("Graphical Orxonox Launcher");
+  orxonoxGUI->connectSignal ("destroy", orxonoxGUI->orxonox_gui_quit);
+  orxonoxGUI->connectSignal ("delete_event", orxonoxGUI->orxonox_gui_quit);
+  
+  Frame* Frametest = new Frame ("Test");
+  orxonoxGUI->fill((Frame*) Frametest);
+  Box* box = new Box ('v');
+  Frametest->fill(box);
+  
+  CheckButton* button = new CheckButton("test");
+  button->connectSignal ("clicked", orxonoxGUI->orxonox_gui_quit);
+  box->fill(button);
+  Slider* slider = new Slider("testslider", 0, 100);
+  slider->connectSignal ("value_changed", slider->OptionChange);
+  box->fill(slider);
+  
+  orxonoxGUI->showall ();
+  
+  gtk_main();
+  return 0;
+}
 
 
@@ -32,4 +32,7 @@
 void Widget::show()
 {
+  /**
+   * Function to Show any Widget
+   */
   gtk_widget_show (widget);
 }
@@ -37,4 +40,7 @@
 void Widget::connectSignal (char* event, gint ( *signal)( GtkWidget*, GdkEvent*, void *))
 {
+  /** 
+   * Connect any signal to any given Sub-widget
+   */
   g_signal_connect (G_OBJECT (this->widget), event, G_CALLBACK (signal), NULL);
 }
@@ -42,4 +48,7 @@
 void Widget::connectSignal (char* event, gint ( *signal)( GtkWidget*, Widget *))
 {
+  /**
+   * Connect a signal with additionally passing the whole Object
+   */
   g_signal_connect (G_OBJECT (this->widget), event, G_CALLBACK (signal), this);
 }
@@ -49,4 +58,7 @@
 void Container::fill (Widget *lowerWidget)
 {
+  /**
+   * fill any given Container with a lowerwidet
+   */
   gtk_container_add (GTK_CONTAINER(this->widget), lowerWidget->widget);
   this->down = lowerWidget;
@@ -59,4 +71,7 @@
 Window::Window (void)
 {
+  /**
+   * Creating a Window
+   */
   widget = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_window_set_policy(GTK_WINDOW(widget), TRUE, TRUE, TRUE);
@@ -65,4 +80,7 @@
 Window::Window (char* windowName)
 {
+  /**
+   * Creating a Window with passing a name
+   */
   widget = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_window_set_policy(GTK_WINDOW(widget), TRUE, TRUE, TRUE);
@@ -71,8 +89,15 @@
 
 Window::~Window ()
-{}
+{
+  /**
+   * Destoying a Window (not implemented)
+   */
+}
 
 void Window::showall ()
 {
+  /**
+   * Shows all Widgets that are included within this Widget
+   */
   gtk_widget_show_all  (widget);
 }
@@ -80,4 +105,7 @@
 void Window::setTitle (char* title)
 {
+  /**
+   * Set The Window title to title
+   */
   gtk_window_set_title (GTK_WINDOW (widget), title);
 }
@@ -86,4 +114,7 @@
 gint Window::orxonox_gui_quit ( GtkWidget *widget, GdkEvent *event, gpointer data)
 {
+  /**
+   * Quits the orxonox_GUI
+   */
   gtk_main_quit();
   return FALSE;
@@ -95,15 +126,28 @@
 Frame::Frame (void)
 {
+  /** 
+   * Creates a new Frame without a name
+   */
   widget = gtk_frame_new ("");
 }
 Frame::Frame (char* title)
 {
+  /**
+   * Creates a new Frame with name title
+   */
   widget = gtk_frame_new (title);
 }
 Frame::~Frame ()
-{}
+{
+  /**
+   * Destroys given Frame (not implemented yet)
+   */
+}
 
 void Frame::setTitle (char* title)
 {
+  /**
+   * Sets the Frames name to title
+   */
   gtk_frame_set_label (GTK_FRAME (widget), title);
 }
@@ -115,8 +159,14 @@
 Box::Box (void)
 {
+  /**
+   * Creates a new horizontal Box
+   */
   widget = gtk_hbox_new(FALSE, 0);
 }
 Box::Box (char boxtype)
 {
+  /**
+   * Creates a new Box if boxtype is 'v' it will be vertically, if 'h' it will be horizontally
+   */
   if (boxtype == 'v')
     {
@@ -130,8 +180,15 @@
 
 Box::~Box ()
-{}
+{
+  /**
+   * Destroys given Frame (not implemented yet)
+   */
+}
 
 void Box::fill (Widget *lowerWidget)
 {
+  /**
+   * Fill a Box with its lowerwidgets
+   */
   gtk_box_pack_start (GTK_BOX(this->widget), lowerWidget->widget, TRUE, TRUE, 0);
 }
@@ -143,5 +200,9 @@
 Button::Button(char* buttonname)
 {
+  /**
+   * Creates a new Button with name buttonname
+   */
   widget = gtk_button_new_with_label(buttonname);
+  option_name = buttonname;
 }
 
@@ -149,5 +210,9 @@
 CheckButton::CheckButton(char* buttonname)
 {
+  /**
+   * Creates a new CheckButton with name buttonname
+   */
   widget = gtk_check_button_new_with_label(buttonname);
+  option_name = buttonname;
 }
 
@@ -155,4 +220,7 @@
 Slider::Slider (char* slidername, int start, int end)
 {
+  /**
+   * Creates a new Slider with name slidername a beginning value of start and an end value of end.
+   */
   widget = gtk_hscale_new_with_range (start, end, 5);
   value = start;
@@ -162,6 +230,8 @@
 gint Slider::OptionChange (GtkWidget *widget, Widget* slider)
 {
-  //Slider * superslider = dynamic_cast<Slider*>(slider)
-    //  dynamic_cast<Slider*>(slider)->value = (int)gtk_range_get_value (GTK_RANGE((Slider*)slider->widget));
-  cout << (int)gtk_range_get_value (GTK_RANGE((Slider*)slider->widget)) << endl;
-}
+  /** 
+   * Writes value, if changed on the slider, to the object.
+   */
+  static_cast<Slider*>(slider)->value = (int)gtk_range_get_value (GTK_RANGE((Slider*)slider->widget));
+  cout << static_cast<Slider*>(slider)->value << endl;
+}