Index: code/branches/buildsystem/CMakeLists.txt
===================================================================
--- code/branches/buildsystem/CMakeLists.txt	(revision 1975)
+++ code/branches/buildsystem/CMakeLists.txt	(revision 1977)
@@ -13,47 +13,26 @@
 SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
-# Check whether we are on a tardis box
+# Check whether we are on a tardis box and set customized paths
 INCLUDE(CheckTardis)
-
 
 ############## Testing options ##################
 
-OPTION(TESTING_ENABLED "Do you want to enable Testing")
-IF (TESTING_ENABLED)
-  ENABLE_TESTING()
-ENDIF(TESTING_ENABLED)
-
-OPTION (NETWORK_TESTING_ENABLED "Do you want to build network testing tools: i.e. chatclient chatserver and alike")
-OPTION (NETWORKTRAFFIC_TESTING_ENABLED "Do you want to build dummyserver4 and dummyclient4")
-
+#OPTION(TESTING_ENABLED "Do you want to enable Testing")
+#IF (TESTING_ENABLED)
+#  ENABLE_TESTING()
+#ENDIF(TESTING_ENABLED)
+#
+#OPTION (NETWORK_TESTING_ENABLED "Do you want to build network testing tools: i.e. chatclient chatserver and alike")
+#OPTION (NETWORKTRAFFIC_TESTING_ENABLED "Do you want to build dummyserver4 and dummyclient4")
 
 ########## Compiler/Linker options ##############
 
-# if on tardis change compiler and reset boost include directory
-IF(IS_TARDIS)
-  MESSAGE("System is a TARDIS: Setting Compiler to g++-4.1.1")
-  # Force-set the compiler on tardis machines, as default points to g++-3.3
-  SET(CMAKE_CXX_COMPILER "g++-4.1.1")
-  # Reset Boost serach path
-  SET(Boost_INCLUDE_DIR "/usr/pack/boost-1.34.1-sd/i686-debian-linux3.1/include")
-ELSE (IS_TARDIS)
-  IF (NOT WIN32)
-    SET(Boost_INCLUDE_DIR "/usr/include/boost")
-  ENDIF (NOT WIN32)
-ENDIF(IS_TARDIS)
-
 # Set binary output directories
 SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
-SET(LIBRARY_OUTPUT_PATH    ${PROJECT_BINARY_DIR}/bin/lib)
+SET(LIBRARY_OUTPUT_PATH    ${PROJECT_BINARY_DIR}/bin)
 
-# Set PATH on Windows, so it finds the DLLs
-IF(CMAKE_HOST_WIN32)
-  FILE(TO_NATIVE_PATH "${LIBRARY_OUTPUT_PATH}" _native_library_path)
-  SET(ENV{PATH} "$ENV{PATH}:${_native_library_path}")
-ENDIF(CMAKE_HOST_WIN32)
-
-# Global compiler/linker flags. force -O2!
-SET(CMAKE_C_FLAGS "$ENV{CFLAGS} -O0 -Wall -g -ggdb")
-SET(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -O0 -Wall -g -ggdb")
+# Global compiler/linker flags.
+SET(CMAKE_C_FLAGS "$ENV{CFLAGS} -Wall -Wextra -Wno-unused-parameter -g -ggdb")
+SET(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -Wall -Wextra -Wno-unused-parameter -g -ggdb")
 #SET(CMAKE_C_FLAGS "$ENV{CFLAGS} -O3")
 #SET(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -O3")
@@ -63,10 +42,4 @@
 SET(CMAKE_SHARED_LINKER_FLAGS " --no-undefined")
 SET(CMAKE_MODULE_LINKER_FLAGS " --no-undefined")
-
-# Use 'cmake -D make_verb:1 path' to get verbose make output when compiling
-IF (MAKE_VERB)
- SET(CMAKE_VERBOSE_MAKEFILE TRUE)
-ENDIF (MAKE_VERB)
-
 
 ############### Library finding #################
@@ -86,50 +59,21 @@
     ENDIF ($ENV{ORXONOX_DEV})
     SET(Boost_LIB_SUFFIX_DEBUG vc80-mt-gd-1_35)
+    #MESSAGE(STATUS ${DEPENDENCY_DIR})
   ENDIF (MSVC)
 ENDIF (WIN32)
-MESSAGE(STATUS ${DEPENDENCY_DIR})
 
 # Performs the search and sets the variables
-FIND_PACKAGE(OGRE)
-FIND_PACKAGE(CEGUI)
-# FIND_PACKAGE(CEGUI_OGRE)
-FIND_PACKAGE(ENet)
+FIND_PACKAGE(OGRE REQUIRED)
+FIND_PACKAGE(CEGUI REQUIRED)
+#FIND_PACKAGE(CEGUI_OGRE REQUIRED)
+FIND_PACKAGE(ENet REQUIRED)
 FIND_PACKAGE(Boost REQUIRED thread filesystem)
-FIND_PACKAGE(OpenAL)
-FIND_PACKAGE(ALUT)
-FIND_PACKAGE(OggVorbis)
-FIND_PACKAGE(ZLIB)
-FIND_PACKAGE(Lua50)
-FIND_PACKAGE(TCL)
-FIND_PACKAGE(DirectX)
-
-# Set the search paths for the linking
-LINK_DIRECTORIES(
-  ${OGRE_LIB_DIR}
-  ${CEGUI_LIB_DIR}
-#  ${CEGUI_SCRIPT_LIB_DIR}
-#  ${CEGUI_OGRE_LIB_DIR}
-  ${ENet_LIBRARY}
-  ${Boost_LIBRARY_DIRS}
-  ${Zlib_LIBRARY_DIR}
-  ${TCL_LIBRARY}
-)
-
-# Set the search paths for include files
-INCLUDE_DIRECTORIES(
-  ${OGRE_INCLUDE_DIR}
-  ${CEGUI_INCLUDE_DIR}
-#  ${CEGUI_OGRE_INCLUDE_DIR}
-  ${ENet_INCLUDE_DIR}
-  ${Boost_INCLUDE_DIRS}
-  ${OPENAL_INCLUDE_DIR}
-  ${ALUT_INCLUDE_DIR}
-  ${VORBIS_INCLUDE_DIR}
-  ${OGG_INCLUDE_DIR}
-#  ${Lua_INCLUDE_DIR}
-  ${TCL_INCLUDE_PATH}
-  ${DirectX_INCLUDE_DIR}
-  ${ZLIB_INCLUDE_DIR}
-)
+FIND_PACKAGE(OpenAL REQUIRED)
+FIND_PACKAGE(ALUT REQUIRED)
+FIND_PACKAGE(OggVorbis REQUIRED)
+FIND_PACKAGE(ZLIB REQUIRED)
+FIND_PACKAGE(Lua50 REQUIRED)
+FIND_PACKAGE(TCL REQUIRED)
+FIND_PACKAGE(DirectX REQUIRED)
 
 # Add main source dir