Index: code/branches/physics/visual_studio/vc8/network.vsprops
===================================================================
--- code/branches/physics/visual_studio/vc8/network.vsprops	(revision 1986)
+++ code/branches/physics/visual_studio/vc8/network.vsprops	(revision 1987)
@@ -9,4 +9,5 @@
 		Name="VCCLCompilerTool"
 		AdditionalOptions="/MP2"
+		AdditionalIncludeDirectories="$(RootDir)src\orxonox"
 		PreprocessorDefinitions="ORXONOX_NO_EXPORTS;NETWORK_STATIC_BUILD"
 	/>
Index: code/branches/physics/visual_studio/vc8/ogrebullet_collisions.vcproj
===================================================================
--- code/branches/physics/visual_studio/vc8/ogrebullet_collisions.vcproj	(revision 1986)
+++ code/branches/physics/visual_studio/vc8/ogrebullet_collisions.vcproj	(revision 1987)
@@ -150,4 +150,12 @@
 					/>
 				</FileConfiguration>
+				<FileConfiguration
+					Name="Release|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						UsePrecompiledHeader="1"
+					/>
+				</FileConfiguration>
 			</File>
 			<File
Index: code/branches/physics/visual_studio/vc8/ogrebullet_collisions.vsprops
===================================================================
--- code/branches/physics/visual_studio/vc8/ogrebullet_collisions.vsprops	(revision 1986)
+++ code/branches/physics/visual_studio/vc8/ogrebullet_collisions.vsprops	(revision 1987)
@@ -8,5 +8,5 @@
 	<Tool
 		Name="VCCLCompilerTool"
-		AdditionalOptions="/MP2 /Zm200"
+		AdditionalOptions="/Zm200"
 		AdditionalIncludeDirectories="$(RootDir)src\bullet;$(RootDir)src\ogrebullet\Collisions"
 		PreprocessorDefinitions="_PRECOMP"
Index: code/branches/physics/visual_studio/vc8/ogrebullet_dynamics.vcproj
===================================================================
--- code/branches/physics/visual_studio/vc8/ogrebullet_dynamics.vcproj	(revision 1986)
+++ code/branches/physics/visual_studio/vc8/ogrebullet_dynamics.vcproj	(revision 1987)
@@ -150,4 +150,12 @@
 					/>
 				</FileConfiguration>
+				<FileConfiguration
+					Name="Release|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						UsePrecompiledHeader="1"
+					/>
+				</FileConfiguration>
 			</File>
 			<File
Index: code/branches/physics/visual_studio/vc8/ogrebullet_dynamics.vsprops
===================================================================
--- code/branches/physics/visual_studio/vc8/ogrebullet_dynamics.vsprops	(revision 1986)
+++ code/branches/physics/visual_studio/vc8/ogrebullet_dynamics.vsprops	(revision 1987)
@@ -8,5 +8,5 @@
 	<Tool
 		Name="VCCLCompilerTool"
-		AdditionalOptions="/MP2 /Zm200"
+		AdditionalOptions="/Zm200"
 		AdditionalIncludeDirectories="$(RootDir)src\bullet;$(RootDir)src\ogrebullet\Collisions;$(RootDir)src\ogrebullet\Dynamics"
 		PreprocessorDefinitions="_PRECOMP"
Index: code/branches/physics/visual_studio/vc8/ogreode.vcproj
===================================================================
--- code/branches/physics/visual_studio/vc8/ogreode.vcproj	(revision 1986)
+++ code/branches/physics/visual_studio/vc8/ogreode.vcproj	(revision 1987)
@@ -197,4 +197,12 @@
 					/>
 				</FileConfiguration>
+				<FileConfiguration
+					Name="Release|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						UsePrecompiledHeader="1"
+					/>
+				</FileConfiguration>
 			</File>
 			<File
Index: code/branches/physics/visual_studio/vc8/orxonox.vcproj
===================================================================
--- code/branches/physics/visual_studio/vc8/orxonox.vcproj	(revision 1986)
+++ code/branches/physics/visual_studio/vc8/orxonox.vcproj	(revision 1987)
@@ -230,4 +230,20 @@
 					RelativePath="..\..\src\orxonox\objects\PhysicsTest.cc"
 					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						ExcludedFromBuild="true"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+						/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						ExcludedFromBuild="true"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+						/>
+					</FileConfiguration>
 				</File>
 				<File
Index: code/branches/physics/visual_studio/vc8/orxonox_vc8.sln
===================================================================
--- code/branches/physics/visual_studio/vc8/orxonox_vc8.sln	(revision 1986)
+++ code/branches/physics/visual_studio/vc8/orxonox_vc8.sln	(revision 1987)
@@ -8,14 +8,20 @@
 	EndProjectSection
 	ProjectSection(ProjectDependencies) = postProject
+		{4733BD1A-E04C-458D-8BFB-5010250EA497} = {4733BD1A-E04C-458D-8BFB-5010250EA497}
+		{35575B59-E1AE-40E8-89C4-2862B5B09B68} = {35575B59-E1AE-40E8-89C4-2862B5B09B68}
+		{40511677-D792-42A1-AD87-DEE31D887F67} = {40511677-D792-42A1-AD87-DEE31D887F67}
+		{63B3E57A-4382-42F3-85EC-E869CFCCA88F} = {63B3E57A-4382-42F3-85EC-E869CFCCA88F}
+		{2240ECD7-2F48-4431-8E1B-25466A384CCC} = {2240ECD7-2F48-4431-8E1B-25466A384CCC}
+		{F101C2F0-1CB9-4A57-827B-6C399A99B28F} = {F101C2F0-1CB9-4A57-827B-6C399A99B28F}
+		{271715F3-5B90-4110-A552-70C788084A86} = {271715F3-5B90-4110-A552-70C788084A86}
+		{77D52DF7-23DD-4739-A4F4-D9BD6C1EA9AD} = {77D52DF7-23DD-4739-A4F4-D9BD6C1EA9AD}
+		{09E86264-CA02-4A60-98EA-61BB3F460160} = {09E86264-CA02-4A60-98EA-61BB3F460160}
+		{C8659D22-3CB7-41C9-A1BC-B40DB70A31A5} = {C8659D22-3CB7-41C9-A1BC-B40DB70A31A5}
+		{41481057-47FD-4BEF-853B-7EF5F975F05E} = {41481057-47FD-4BEF-853B-7EF5F975F05E}
+		{BA753941-F455-43A2-925C-7F3E02F6A995} = {BA753941-F455-43A2-925C-7F3E02F6A995}
 		{4BBBB49F-3203-4BB4-AAE3-48BCA96FCB4F} = {4BBBB49F-3203-4BB4-AAE3-48BCA96FCB4F}
 		{BBA88DC2-CD78-4C00-814B-183899090F3E} = {BBA88DC2-CD78-4C00-814B-183899090F3E}
 		{71FC0211-5EB5-4637-BE8A-A48EC3CC27D0} = {71FC0211-5EB5-4637-BE8A-A48EC3CC27D0}
 		{35E36A06-0A5C-4A0D-9AB6-5A05EAA87626} = {35E36A06-0A5C-4A0D-9AB6-5A05EAA87626}
-		{63B3E57A-4382-42F3-85EC-E869CFCCA88F} = {63B3E57A-4382-42F3-85EC-E869CFCCA88F}
-		{4733BD1A-E04C-458D-8BFB-5010250EA497} = {4733BD1A-E04C-458D-8BFB-5010250EA497}
-		{35575B59-E1AE-40E8-89C4-2862B5B09B68} = {35575B59-E1AE-40E8-89C4-2862B5B09B68}
-		{2240ECD7-2F48-4431-8E1B-25466A384CCC} = {2240ECD7-2F48-4431-8E1B-25466A384CCC}
-		{271715F3-5B90-4110-A552-70C788084A86} = {271715F3-5B90-4110-A552-70C788084A86}
-		{F101C2F0-1CB9-4A57-827B-6C399A99B28F} = {F101C2F0-1CB9-4A57-827B-6C399A99B28F}
 	EndProjectSection
 EndProject